package pogr;

import java.awt.Canvas;
import java.awt.Cursor;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JLabel;

/**
 * Abstraktní třída, tkerá obsahuje základní funkce pro Floodfill
 * @author Kamil Ondrák
 */
public abstract class Flood extends Algoritmus {

    protected boolean postup;

    //private LinkedList<Point> fronta = new LinkedList<Point>();

    /**
     * Funkce, která obstarává umístění prvnotního semínka do plátna.
     * Především volá funkci vyplň. Dále pak dává uživateli najevo, že se něco děje -
     * změní kurzor myší a vypíše zprávu.
     * @param evt   Událost - kliknutí myší
     */
    protected void platnoMouseClicked(MouseEvent evt) {
        zprava("Vykresluji");
        Cursor hourglassCursor = new Cursor(Cursor.WAIT_CURSOR);
        Cursor defaultCursor = new Cursor(Cursor.DEFAULT_CURSOR);
        platno.setCursor(hourglassCursor);
        //Nutné, aby se stihl změnit kurzor myši před započetím vyplňování.
        try {
            Thread.sleep(1);
        } catch (InterruptedException ex) {
            Logger.getLogger(Flood.class.getName()).log(Level.SEVERE, null, ex);
        }
        vypln(evt.getPoint());
        platno.removeMouseListener(platno.getMouseListeners()[0]);
        zprava("Hotovo");
        //g.drawImage(obrazek, 0, 0, io);
        platno.setObrazek(obrazek);
        platno.repaint();
        
        platno.setCursor(defaultCursor);
    }

    /**
     * Abstrakní třída pro vyplňění oblasti
     * @param b Bod, kde je umístěno počáteční semínko
     */
    protected abstract void vypln(Point b);

    /**
     * Konstruktor třídy
     * @param platno    Plátno pro kreslení
     * @param label     Label pro vypisování zpráv
     */
    public Flood(MujCanvas platno, JLabel label) {
        super(platno, label);
    }

    /**
     * Funkce dovolí uživateli zvolit počáteční semínko, proto přidá k plátnu listener, který čeká na událost kliknutí.
     * @param _postup
     */
    @Override
    public void vyplnPolygon(boolean _postup) {
        postup=_postup;
        zprava("Zvolte počáteční bod");
        setBarva(0xFF0000);
        platno.addMouseListener(new java.awt.event.MouseAdapter() {
            @Override
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                platnoMouseClicked(evt);
            }
        });
        
    }
}
