package pogr;

import java.awt.Canvas;
import java.awt.Point;
import java.util.LinkedList;
import javax.swing.JLabel;

/**
 * Třída, která umožňuje vyplnění oblasti metodou Floodfill za použití fronty
 * @author Kamil Ondrák
 */
public class FloodFIFO extends Flood {

    private LinkedList<Point> fronta = new LinkedList<Point>();

    /**
     * Funkce pro samotné vyplnění oblasti
     * @param b Umístění počátečního semínka
     */
    protected void vypln(Point b) {
        
        System.out.print("Barva na zacatku je " + obrazek.getRGB(b.x, b.y) + "\n");
        Point bod = new Point();
        if (obrazek.getRGB(b.x, b.y) == -1) {//0xFFFFFF) {
            fronta.push(b);
            while (!fronta.isEmpty()) {
                bod = fronta.pollLast();
                obrazek.setRGB(bod.x, bod.y, barva);
                if ((bod.x<platno.getWidth()-1) && (obrazek.getRGB(bod.x + 1, bod.y) == -1) ) {
                    if (!fronta.contains(new Point(bod.x + 1, bod.y))) {
                        fronta.push(new Point(bod.x + 1, bod.y));
                    }
                }
                if ((bod.y<platno.getHeight()-1) && (obrazek.getRGB(bod.x, bod.y + 1) == -1) ) {
                    if (!fronta.contains(new Point(bod.x, bod.y + 1))) {
                        fronta.push(new Point(bod.x, bod.y + 1));
                    }
                }
                if ( (bod.x>0) && (obrazek.getRGB(bod.x - 1, bod.y) == -1) ) {
                    if (!fronta.contains(new Point(bod.x - 1, bod.y))) {
                        fronta.push(new Point(bod.x - 1, bod.y));
                    }
                }
                if ((bod.y>0) && (obrazek.getRGB(bod.x, bod.y - 1) == -1) ) {
                    if (!fronta.contains(new Point(bod.x, bod.y - 1))) {
                        fronta.push(new Point(bod.x, bod.y - 1));
                    }
                }
                System.out.print("Fronta ma delku " + fronta.size() + "\n");
                if (postup) {
                    //Vynucene vzkresleni
                    g.drawImage(obrazek, 0, 0, null);
                }
            }
            zprava("Hotovo");

        }
        else {
            zprava("Zvolit lze pouze bílý bod.");
        }
    }
    /**
     * Konstruktor
     * @param platno    Plátno pro kreslení
     * @param label     Label pro zprávy
     */
    public FloodFIFO(MujCanvas platno, JLabel label) {
        super(platno,label);
    }

}
