package pogr;

import java.awt.Canvas;
import java.awt.Point;
import java.util.Stack;
import javax.swing.JLabel;

/**
 * Třída, která umožňuje vyplnění oblasti metodou Floodfill za použití zásobníku
 * @author Kamil Ondrák
 */
public class FloodLIFO extends Flood {

    private Stack<Point> zas = new Stack<Point>(); //zasobnik

    /**
     * Funkce pro samotné vyplnění oblasti
     * @param b Umístění počátečního semínka
     */
    protected void vypln(Point b) {
        System.out.print("Barva na zacatku je " + obrazek.getRGB(b.x, b.y));
        Point bod = new Point();
        if (obrazek.getRGB(b.x, b.y) == -1) {//0xFFFFFF - bílá
            zas.push(b);
            while (!zas.empty()) {
                bod = zas.pop();
                obrazek.setRGB(bod.x, bod.y, barva);
                if ((bod.x<platno.getWidth()-1) && (obrazek.getRGB(bod.x + 1, bod.y) == -1) ) {
                    if (!zas.contains(new Point(bod.x + 1, bod.y))) {
                        zas.push(new Point(bod.x + 1, bod.y));
                    }
                }
                if ( (bod.x>0) && (obrazek.getRGB(bod.x - 1, bod.y) == -1) ) {
                    if (!zas.contains(new Point(bod.x - 1, bod.y))) {
                        zas.push(new Point(bod.x - 1, bod.y));
                    }
                }
                if ((bod.y<platno.getHeight()-1) && (obrazek.getRGB(bod.x, bod.y + 1) == -1) ) {
                    if (!zas.contains(new Point(bod.x, bod.y + 1))) {
                        zas.push(new Point(bod.x, bod.y + 1));
                    }
                }
                if ((bod.y>0) && (obrazek.getRGB(bod.x, bod.y - 1) == -1) ) {
                    if (!zas.contains(new Point(bod.x, bod.y - 1))) {
                        zas.push(new Point(bod.x, bod.y - 1));
                    }
                }
                System.out.print("Velikost zásobníku je "+zas.size()+"\n");
                if (postup) {
                    //Vynucene vzkresleni
                    g.drawImage(obrazek, 0, 0, null);
                }
            }
            zprava("Hotovo");
        }
        else {
            zprava("Zvolit lze pouze bílý bod.");
        }



    }

    /**
     * Konstruktor
     * @param platno    Plátno pro kreslení
     * @param label     Label pro zprávy
     */
    public FloodLIFO(MujCanvas platno, JLabel label) {
        super(platno, label);
    }
}
