/*
 * PogrApp.java
 */

package pogr;

import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * Hlavní třída apliakce
 */
public class PogrApp extends SingleFrameApplication {

    /**
     * Na začátku je vytvořeno a zobrazeno hlavní okno aplikace
     */
    @Override protected void startup() {
        show(new PogrView(this));
    }

    /**
     * Metoda pro inicializace okna. Zobrazené okno už je připraveno díky
     * kodu vygenerovánemu jinde, proto je metoda prázdná.
     */
    @Override protected void configureWindow(java.awt.Window root) {
    }

    /**
     * Spolehlivý statický getter pro instanci aplikace.
     * @return instance PogrApp
     */
    public static PogrApp getApplication() {
        return Application.getInstance(PogrApp.class);
    }

    /**
     * Hlavní metoda spouštějící aplikaci.
     * @param args argumenty zadané při spouštění
     */
    public static void main(String[] args) {
        launch(PogrApp.class, args);
    }
}
