/*
 * PogrView.java
 */

package pogr;

import java.awt.Cursor;
import java.awt.Point;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ButtonGroup;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFrame;

/**
 * Hlavní okno aplikace
 */
public class PogrView extends FrameView {

    private Algoritmus alg;
    private ButtonGroup groupAkce = new ButtonGroup();
    //private MujCanvas canvas2;

    private void zmenaAlgoritmu() {
        butVykresli.setEnabled(true);
        butVypln.setEnabled(false);
        butSmaz.setEnabled(true);
        //if (canvas2.getMouseListeners() == null) {
            canvas2.addMouseListener(new java.awt.event.MouseAdapter() {
                @Override
                public void mouseClicked(java.awt.event.MouseEvent evt) {
                    canvas2MouseClicked(evt);
                }
            });
        //}
        canvas2.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
    }

    public PogrView(SingleFrameApplication app) {
        super(app);

        initComponents();

        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
               } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                }
            }
            
        });

        groupAkce.clearSelection();
    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = PogrApp.getApplication().getMainFrame();
            aboutBox = new PogrAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        PogrApp.getApplication().show(aboutBox);
    }

    /** Tuto metodu volá konstruktor při vytváření okna
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        canvas2 = new MujCanvas();
        butVykresli = new javax.swing.JButton();
        butVypln = new javax.swing.JButton();
        butSmaz = new javax.swing.JButton();
        labZpravy = new javax.swing.JLabel();
        labZpravy2 = new javax.swing.JLabel();
        checkPrubeh = new javax.swing.JCheckBox();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jRadioButtonMenuItem2 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem3 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem4 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem5 = new javax.swing.JRadioButtonMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();

        mainPanel.setMaximumSize(new java.awt.Dimension(750, 500));
        mainPanel.setMinimumSize(new java.awt.Dimension(750, 500));
        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.setPreferredSize(new java.awt.Dimension(750, 500));
        mainPanel.setRequestFocusEnabled(false);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(pogr.PogrApp.class).getContext().getResourceMap(PogrView.class);
        canvas2.setBackground(resourceMap.getColor("canvas2.background")); // NOI18N
        canvas2.setName("canvas2"); // NOI18N
        canvas2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                canvas2MouseClicked(evt);
            }
        });
        canvas2.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                canvas2MouseMoved(evt);
            }
        });
        
        butVykresli.setText(resourceMap.getString("butVykresli.text")); // NOI18N
        butVykresli.setEnabled(false);
        butVykresli.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        butVykresli.setName("butVykresli"); // NOI18N
        butVykresli.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                butVykresliActionPerformed(evt);
            }
        });

        butVypln.setText(resourceMap.getString("butVypln.text")); // NOI18N
        butVypln.setEnabled(false);
        butVypln.setName("butVypln"); // NOI18N
        butVypln.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                butVyplnActionPerformed(evt);
            }
        });

        butSmaz.setText(resourceMap.getString("butSmaz.text")); // NOI18N
        butSmaz.setEnabled(false);
        butSmaz.setName("butSmaz"); // NOI18N
        butSmaz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                butSmazActionPerformed(evt);
            }
        });

        labZpravy.setText(resourceMap.getString("labZpravy.text")); // NOI18N
        labZpravy.setName("labZpravy"); // NOI18N

        labZpravy2.setText(resourceMap.getString("labZpravy2.text")); // NOI18N
        labZpravy2.setName("labZpravy2"); // NOI18N

        checkPrubeh.setSelected(true);
        checkPrubeh.setText(resourceMap.getString("checkPrubeh.text")); // NOI18N
        checkPrubeh.setName("checkPrubeh"); // NOI18N

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(canvas2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 847, Short.MAX_VALUE)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(labZpravy2)
                .addContainerGap(837, Short.MAX_VALUE))
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(labZpravy)
                .addGap(52, 52, 52)
                .addComponent(butSmaz)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(checkPrubeh)
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addComponent(butVypln)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(butVykresli)))
                .addContainerGap(207, Short.MAX_VALUE))
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addComponent(canvas2, javax.swing.GroupLayout.PREFERRED_SIZE, 444, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labZpravy)
                    .addComponent(butSmaz)
                    .addComponent(butVypln)
                    .addComponent(butVykresli))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(checkPrubeh)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 25, Short.MAX_VALUE)
                .addComponent(labZpravy2)
                .addContainerGap())
        );

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(pogr.PogrApp.class).getContext().getActionMap(PogrView.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setText(resourceMap.getString("exitMenuItem.text")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        jMenu1.setText(resourceMap.getString("jMenu1.text")); // NOI18N
        jMenu1.setName("jMenu1"); // NOI18N

        groupAkce.add(jRadioButtonMenuItem2);
        jRadioButtonMenuItem2.setSelected(true);
        jRadioButtonMenuItem2.setText(resourceMap.getString("jRadioButtonMenuItem2.text")); // NOI18N
        jRadioButtonMenuItem2.setName("jRadioButtonMenuItem2"); // NOI18N
        jRadioButtonMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem2);

        groupAkce.add(jRadioButtonMenuItem3);
        jRadioButtonMenuItem3.setSelected(true);
        jRadioButtonMenuItem3.setText(resourceMap.getString("jRadioButtonMenuItem3.text")); // NOI18N
        jRadioButtonMenuItem3.setName("jRadioButtonMenuItem3"); // NOI18N
        jRadioButtonMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem3);

        groupAkce.add(jRadioButtonMenuItem4);
        jRadioButtonMenuItem4.setSelected(true);
        jRadioButtonMenuItem4.setText(resourceMap.getString("jRadioButtonMenuItem4.text")); // NOI18N
        jRadioButtonMenuItem4.setName("jRadioButtonMenuItem4"); // NOI18N
        jRadioButtonMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem4ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem4);

        groupAkce.add(jRadioButtonMenuItem5);
        jRadioButtonMenuItem5.setSelected(true);
        jRadioButtonMenuItem5.setText(resourceMap.getString("jRadioButtonMenuItem5.text")); // NOI18N
        jRadioButtonMenuItem5.setName("jRadioButtonMenuItem5"); // NOI18N
        jRadioButtonMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem5ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem5);

        menuBar.add(jMenu1);

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setText(resourceMap.getString("aboutMenuItem.text")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(statusPanelSeparator, javax.swing.GroupLayout.DEFAULT_SIZE, 847, Short.MAX_VALUE)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 827, Short.MAX_VALUE)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addComponent(statusPanelSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 2, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel))
                .addGap(3, 3, 3))
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
    }// </editor-fold>//GEN-END:initComponents

    private void butVykresliActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_butVykresliActionPerformed
        if (alg.vykresliPolygon()) {
            butVykresli.setEnabled(false);
            butVypln.setEnabled(true);
            while (canvas2.getMouseListeners().length!=0) {
                canvas2.removeMouseListener(canvas2.getMouseListeners()[0]);
            }
            canvas2.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            //canvas2.validate();
        }
    }//GEN-LAST:event_butVykresliActionPerformed

    private void butVyplnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_butVyplnActionPerformed
        JFrame mainFrame = PogrApp.getApplication().getMainFrame();
        mainFrame.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        canvas2.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        alg.vyplnPolygon(checkPrubeh.isSelected());
        butVypln.setEnabled(false);
        mainFrame.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        canvas2.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

    }//GEN-LAST:event_butVyplnActionPerformed

    private void butSmazActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_butSmazActionPerformed
        
        butVykresli.setEnabled(true);
        butVypln.setEnabled(false);
        butSmaz.setEnabled(true);
        canvas2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                canvas2MouseClicked(evt);
            }
        });
        System.out.print("Mazaeme\n");
        alg.smaz();
        canvas2.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
    }//GEN-LAST:event_butSmazActionPerformed

    private void jRadioButtonMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem2ActionPerformed
        //butSmazActionPerformed(null);
        if (alg!=null) {
            alg.smaz();
        }
        alg = new Scanline(canvas2, labZpravy2);

        labZpravy.setText("Vyplňování pomocí rozkaldových řádků");
        zmenaAlgoritmu();
    }//GEN-LAST:event_jRadioButtonMenuItem2ActionPerformed

    private void jRadioButtonMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem3ActionPerformed
        if (alg!=null) {
            alg.smaz();
        }
        alg = new Stencil(canvas2, labZpravy2);
        labZpravy.setText("Vyplňování pomocí stencil bufferu");
        zmenaAlgoritmu();
    }//GEN-LAST:event_jRadioButtonMenuItem3ActionPerformed

    private void jRadioButtonMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem4ActionPerformed
        if (alg!=null) {
            alg.smaz();
        }
        alg = new FloodLIFO(canvas2, labZpravy2);
        labZpravy.setText("Vyplňování metodou Floodfill za použití zásobníku (LIFO)");
        zmenaAlgoritmu();

    }//GEN-LAST:event_jRadioButtonMenuItem4ActionPerformed

    private void jRadioButtonMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem5ActionPerformed
        if (alg!=null) {
            alg.smaz();
        }
        alg = new FloodFIFO(canvas2, labZpravy2);
        labZpravy.setText("Vyplňování metodou Floodfill za použití fronty (FIFO)");
        zmenaAlgoritmu();
    }//GEN-LAST:event_jRadioButtonMenuItem5ActionPerformed

    private void canvas2MouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvas2MouseMoved
        Point m = evt.getPoint();
        statusMessageLabel.setText( m.x + ":" + m.y );
}//GEN-LAST:event_canvas2MouseMoved

    private void canvas2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_canvas2MouseClicked
        if (alg!=null) {
            alg.pridejBod(evt.getPoint());
        }
}//GEN-LAST:event_canvas2MouseClicked

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton butSmaz;
    private javax.swing.JButton butVykresli;
    private javax.swing.JButton butVypln;
    private MujCanvas canvas2;
    private javax.swing.JCheckBox checkPrubeh;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem2;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem3;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem4;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem5;
    private javax.swing.JLabel labZpravy;
    private javax.swing.JLabel labZpravy2;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables

    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;

    private JDialog aboutBox;
}
